<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_201) on Tue Jun 11 21:47:08 AEST 2019 -->
<title>Closer (worldedit-core 7.0.0 API)</title>
<meta name="date" content="2019-06-11">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Closer (worldedit-core 7.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":9,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../com/sk89q/worldedit/util/io/ForwardSeekableInputStream.html" title="class in com.sk89q.worldedit.util.io"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/util/io/Closer.html" target="_top">Frames</a></li>
<li><a href="Closer.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.sk89q.worldedit.util.io</div>
<h2 title="Class Closer" class="title">Class Closer</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>com.sk89q.worldedit.util.io.Closer</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.io.Closeable, java.lang.AutoCloseable</dd>
</dl>
<hr>
<br>
<pre>public final class <span class="typeNameLabel">Closer</span>
extends java.lang.Object
implements java.io.Closeable</pre>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#close--">close</a></span>()</code>
<div class="block">Closes all <code>Closeable</code> instances that have been added to this <code>Closer</code>.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>static <a href="../../../../../com/sk89q/worldedit/util/io/Closer.html" title="class in com.sk89q.worldedit.util.io">Closer</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#create--">create</a></span>()</code>
<div class="block">Creates a new <a href="../../../../../com/sk89q/worldedit/util/io/Closer.html" title="class in com.sk89q.worldedit.util.io"><code>Closer</code></a>.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>&lt;C extends java.io.Closeable&gt;<br>C</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#register-C-">register</a></span>(C&nbsp;closeable)</code>
<div class="block">Registers the given <code>closeable</code> to be closed when this <code>Closer</code> is
 <a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#close--">closed</a>.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>&lt;Z extends java.util.zip.ZipFile&gt;<br>Z</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#register-Z-">register</a></span>(Z&nbsp;zipFile)</code>
<div class="block">Registers the given <code>zipFile</code> to be closed when this <code>Closer</code> is
 <a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#close--">closed</a>.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>java.lang.RuntimeException</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#rethrow-java.lang.Throwable-">rethrow</a></span>(java.lang.Throwable&nbsp;e)</code>
<div class="block">Stores the given throwable and rethrows it.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>&lt;X extends java.lang.Exception&gt;<br>java.lang.RuntimeException</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#rethrow-java.lang.Throwable-java.lang.Class-">rethrow</a></span>(java.lang.Throwable&nbsp;e,
       java.lang.Class&lt;X&gt;&nbsp;declaredType)</code>
<div class="block">Stores the given throwable and rethrows it.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>&lt;X1 extends java.lang.Exception,X2 extends java.lang.Exception&gt;<br>java.lang.RuntimeException</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#rethrow-java.lang.Throwable-java.lang.Class-java.lang.Class-">rethrow</a></span>(java.lang.Throwable&nbsp;e,
       java.lang.Class&lt;X1&gt;&nbsp;declaredType1,
       java.lang.Class&lt;X2&gt;&nbsp;declaredType2)</code>
<div class="block">Stores the given throwable and rethrows it.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="create--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>create</h4>
<pre>public static&nbsp;<a href="../../../../../com/sk89q/worldedit/util/io/Closer.html" title="class in com.sk89q.worldedit.util.io">Closer</a>&nbsp;create()</pre>
<div class="block">Creates a new <a href="../../../../../com/sk89q/worldedit/util/io/Closer.html" title="class in com.sk89q.worldedit.util.io"><code>Closer</code></a>.</div>
</li>
</ul>
<a name="register-java.io.Closeable-">
<!--   -->
</a><a name="register-C-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>register</h4>
<pre>public&nbsp;&lt;C extends java.io.Closeable&gt;&nbsp;C&nbsp;register(C&nbsp;closeable)</pre>
<div class="block">Registers the given <code>closeable</code> to be closed when this <code>Closer</code> is
 <a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#close--">closed</a>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the given <code>closeable</code></dd>
</dl>
</li>
</ul>
<a name="register-java.util.zip.ZipFile-">
<!--   -->
</a><a name="register-Z-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>register</h4>
<pre>public&nbsp;&lt;Z extends java.util.zip.ZipFile&gt;&nbsp;Z&nbsp;register(Z&nbsp;zipFile)</pre>
<div class="block">Registers the given <code>zipFile</code> to be closed when this <code>Closer</code> is
 <a href="../../../../../com/sk89q/worldedit/util/io/Closer.html#close--">closed</a>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the given <code>closeable</code></dd>
</dl>
</li>
</ul>
<a name="rethrow-java.lang.Throwable-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rethrow</h4>
<pre>public&nbsp;java.lang.RuntimeException&nbsp;rethrow(java.lang.Throwable&nbsp;e)
                                   throws java.io.IOException</pre>
<div class="block">Stores the given throwable and rethrows it. It will be rethrown as is if it is an
 <code>IOException</code>, <code>RuntimeException</code> or <code>Error</code>. Otherwise, it will be rethrown
 wrapped in a <code>RuntimeException</code>. <b>Note:</b> Be sure to declare all of the checked
 exception types your try block can throw when calling an overload of this method so as to avoid
 losing the original exception type.

 <p>This method always throws, and as such should be called as
 <code>throw closer.rethrow(e);</code> to ensure the compiler knows that it will throw.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this method does not return; it always throws</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.io.IOException</code> - when the given throwable is an IOException</dd>
</dl>
</li>
</ul>
<a name="rethrow-java.lang.Throwable-java.lang.Class-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rethrow</h4>
<pre>public&nbsp;&lt;X extends java.lang.Exception&gt;&nbsp;java.lang.RuntimeException&nbsp;rethrow(java.lang.Throwable&nbsp;e,
                                                                          java.lang.Class&lt;X&gt;&nbsp;declaredType)
                                                                   throws java.io.IOException,
                                                                          X extends java.lang.Exception</pre>
<div class="block">Stores the given throwable and rethrows it. It will be rethrown as is if it is an
 <code>IOException</code>, <code>RuntimeException</code>, <code>Error</code> or a checked exception of the
 given type. Otherwise, it will be rethrown wrapped in a <code>RuntimeException</code>. <b>Note:</b>
 Be sure to declare all of the checked exception types your try block can throw when calling an
 overload of this method so as to avoid losing the original exception type.

 <p>This method always throws, and as such should be called as
 <code>throw closer.rethrow(e, ...);</code> to ensure the compiler knows that it will throw.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this method does not return; it always throws</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.io.IOException</code> - when the given throwable is an IOException</dd>
<dd><code>X</code> - when the given throwable is of the declared type X</dd>
<dd><code>X extends java.lang.Exception</code></dd>
</dl>
</li>
</ul>
<a name="rethrow-java.lang.Throwable-java.lang.Class-java.lang.Class-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rethrow</h4>
<pre>public&nbsp;&lt;X1 extends java.lang.Exception,X2 extends java.lang.Exception&gt;&nbsp;java.lang.RuntimeException&nbsp;rethrow(java.lang.Throwable&nbsp;e,
                                                                                                          java.lang.Class&lt;X1&gt;&nbsp;declaredType1,
                                                                                                          java.lang.Class&lt;X2&gt;&nbsp;declaredType2)
                                                                                                   throws java.io.IOException,
                                                                                                          X1 extends java.lang.Exception,
                                                                                                          X2 extends java.lang.Exception</pre>
<div class="block">Stores the given throwable and rethrows it. It will be rethrown as is if it is an
 <code>IOException</code>, <code>RuntimeException</code>, <code>Error</code> or a checked exception of either
 of the given types. Otherwise, it will be rethrown wrapped in a <code>RuntimeException</code>.
 <b>Note:</b> Be sure to declare all of the checked exception types your try block can throw
 when calling an overload of this method so as to avoid losing the original exception type.

 <p>This method always throws, and as such should be called as
 <code>throw closer.rethrow(e, ...);</code> to ensure the compiler knows that it will throw.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this method does not return; it always throws</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.io.IOException</code> - when the given throwable is an IOException</dd>
<dd><code>X1</code> - when the given throwable is of the declared type X1</dd>
<dd><code>X2</code> - when the given throwable is of the declared type X2</dd>
<dd><code>X1 extends java.lang.Exception</code></dd>
</dl>
</li>
</ul>
<a name="close--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close()
           throws java.io.IOException</pre>
<div class="block">Closes all <code>Closeable</code> instances that have been added to this <code>Closer</code>. If an
 exception was thrown in the try block and passed to one of the <code>exceptionThrown</code> methods,
 any exceptions thrown when attempting to close a closeable will be suppressed. Otherwise, the
 <i>first</i> exception to be thrown from an attempt to close a closeable will be thrown and any
 additional exceptions that are thrown after that will be suppressed.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>close</code>&nbsp;in interface&nbsp;<code>java.io.Closeable</code></dd>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>close</code>&nbsp;in interface&nbsp;<code>java.lang.AutoCloseable</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev&nbsp;Class</li>
<li><a href="../../../../../com/sk89q/worldedit/util/io/ForwardSeekableInputStream.html" title="class in com.sk89q.worldedit.util.io"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/worldedit/util/io/Closer.html" target="_top">Frames</a></li>
<li><a href="Closer.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
